/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "basic-block.h"

/**** Prototypes ****/


/**** Definitions ****/

static PyObject *
gcc_Edge_get_src(PyGccEdge *self, void *closure)
{
    return gcc_python_make_wrapper_basic_block(self->e->src);
}

static PyObject *
gcc_Edge_get_dest(PyGccEdge *self, void *closure)
{
    return gcc_python_make_wrapper_basic_block(self->e->dest);
}

static PyObject *
gcc_Edge_get_fallthru(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_FALLTHRU);
}

static PyObject *
gcc_Edge_get_abnormal(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_ABNORMAL);
}

static PyObject *
gcc_Edge_get_abnormal_call(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_ABNORMAL_CALL);
}

static PyObject *
gcc_Edge_get_eh(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_EH);
}

static PyObject *
gcc_Edge_get_fake(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_FAKE);
}

static PyObject *
gcc_Edge_get_dfs_back(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_DFS_BACK);
}

static PyObject *
gcc_Edge_get_can_fallthru(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_CAN_FALLTHRU);
}

static PyObject *
gcc_Edge_get_irreducible_loop(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_IRREDUCIBLE_LOOP);
}

static PyObject *
gcc_Edge_get_sibcall(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_SIBCALL);
}

static PyObject *
gcc_Edge_get_loop_exit(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_LOOP_EXIT);
}

static PyObject *
gcc_Edge_get_true_value(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_TRUE_VALUE);
}

static PyObject *
gcc_Edge_get_false_value(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_FALSE_VALUE);
}

static PyObject *
gcc_Edge_get_executable(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_EXECUTABLE);
}

static PyObject *
gcc_Edge_get_crossing(PyGccEdge *self, void *closure)
{
    return PyBool_FromLong(self->e->flags & EDGE_CROSSING);
}

static PyGetSetDef gcc_Edge_getset_table[] = {
    {"src",
     (getter)gcc_Edge_get_src,
     (setter)NULL,
     "The source gcc.BasicBlock of this edge",
     NULL},
    {"dest",
     (getter)gcc_Edge_get_dest,
     (setter)NULL,
     "The destination gcc.BasicBlock of this edge",
     NULL},
    {"fallthru",
     (getter)gcc_Edge_get_fallthru,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_FALLTHRU",
     NULL},
    {"abnormal",
     (getter)gcc_Edge_get_abnormal,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_ABNORMAL",
     NULL},
    {"abnormal_call",
     (getter)gcc_Edge_get_abnormal_call,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_ABNORMAL_CALL",
     NULL},
    {"eh",
     (getter)gcc_Edge_get_eh,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_EH",
     NULL},
    {"fake",
     (getter)gcc_Edge_get_fake,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_FAKE",
     NULL},
    {"dfs_back",
     (getter)gcc_Edge_get_dfs_back,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_DFS_BACK",
     NULL},
    {"can_fallthru",
     (getter)gcc_Edge_get_can_fallthru,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_CAN_FALLTHRU",
     NULL},
    {"irreducible_loop",
     (getter)gcc_Edge_get_irreducible_loop,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_IRREDUCIBLE_LOOP",
     NULL},
    {"sibcall",
     (getter)gcc_Edge_get_sibcall,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_SIBCALL",
     NULL},
    {"loop_exit",
     (getter)gcc_Edge_get_loop_exit,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_LOOP_EXIT",
     NULL},
    {"true_value",
     (getter)gcc_Edge_get_true_value,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_TRUE_VALUE",
     NULL},
    {"false_value",
     (getter)gcc_Edge_get_false_value,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_FALSE_VALUE",
     NULL},
    {"executable",
     (getter)gcc_Edge_get_executable,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_EXECUTABLE",
     NULL},
    {"crossing",
     (getter)gcc_Edge_get_crossing,
     (setter)NULL,
     "Boolean, corresponding to flag EDGE_CROSSING",
     NULL},
    {NULL}  /* Sentinel */
};

PyTypeObject gcc_EdgeType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.Edge", /*tp_name*/
    sizeof(struct PyGccEdge), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = gcc_Edge_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)NULL,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};

static PyObject *
gcc_BasicBlock_get_index(PyGccBasicBlock *self, void *closure)
{
    return gcc_python_int_from_long(self->bb->index);
}

static PyGetSetDef gcc_BasicBlock_getset_table[] = {
    {"preds",
     (getter)gcc_BasicBlock_get_preds,
     (setter)NULL,
     "The list of predecessor gcc.Edge instances leading into this block",
     NULL},
    {"succs",
     (getter)gcc_BasicBlock_get_succs,
     (setter)NULL,
     "The list of successor gcc.Edge instances leading out of this block",
     NULL},
    {"gimple",
     (getter)gcc_BasicBlock_get_gimple,
     (setter)NULL,
     "The list of gcc.Gimple instructions, if appropriate for this pass, or None",
     NULL},
    {"phi_nodes",
     (getter)gcc_BasicBlock_get_phi_nodes,
     (setter)NULL,
     "The list of gcc.GimplePhi phoney functions, if appropriate for this pass, or None",
     NULL},
    {"rtl",
     (getter)gcc_BasicBlock_get_rtl,
     (setter)NULL,
     "The list of gcc.Rtl instructions, if appropriate for this pass, or None",
     NULL},
    {"index",
     (getter)gcc_BasicBlock_get_index,
     (setter)NULL,
     "NULL",
     NULL},
    {NULL}  /* Sentinel */
};

PyTypeObject gcc_BasicBlockType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.BasicBlock", /*tp_name*/
    sizeof(struct PyGccBasicBlock), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = gcc_BasicBlock_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)NULL,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};

static PyObject *
gcc_Cfg_get_entry(PyGccCfg *self, void *closure)
{
    return gcc_python_make_wrapper_basic_block(self->cfg->x_entry_block_ptr);
}

static PyObject *
gcc_Cfg_get_exit(PyGccCfg *self, void *closure)
{
    return gcc_python_make_wrapper_basic_block(self->cfg->x_exit_block_ptr);
}

static PyGetSetDef gcc_Cfg_getset_table[] = {
    {"basic_blocks",
     (getter)gcc_Cfg_get_basic_blocks,
     (setter)NULL,
     "The list of gcc.BasicBlock instances in this graph",
     NULL},
    {"entry",
     (getter)gcc_Cfg_get_entry,
     (setter)NULL,
     "The initial gcc.BasicBlock in this graph",
     NULL},
    {"exit",
     (getter)gcc_Cfg_get_exit,
     (setter)NULL,
     "The final gcc.BasicBlock in this graph",
     NULL},
    {NULL}  /* Sentinel */
};

PyTypeObject gcc_CfgType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.Cfg", /*tp_name*/
    sizeof(struct PyGccCfg), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = gcc_Cfg_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)NULL,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


int autogenerated_cfg_init_types(void)
{
    if (PyType_Ready(&gcc_EdgeType) < 0)
        goto error;

    if (PyType_Ready(&gcc_BasicBlockType) < 0)
        goto error;

    if (PyType_Ready(&gcc_CfgType) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_cfg_add_types(PyObject *m)
{
    Py_INCREF(&gcc_EdgeType);
    PyModule_AddObject(m, "Edge", (PyObject *)&gcc_EdgeType);

    Py_INCREF(&gcc_BasicBlockType);
    PyModule_AddObject(m, "BasicBlock", (PyObject *)&gcc_BasicBlockType);

    Py_INCREF(&gcc_CfgType);
    PyModule_AddObject(m, "Cfg", (PyObject *)&gcc_CfgType);


}

