/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "diagnostic.h"

/**** Prototypes ****/


/**** Definitions ****/

static PyObject *
gcc_Option_get_text(PyGccOption *self, void *closure)
{
    return gcc_python_string_or_none(gcc_python_option_to_cl_option(self)->opt_text);
}

static PyObject *
gcc_Option_get_help(PyGccOption *self, void *closure)
{
    return gcc_python_string_or_none(gcc_python_option_to_cl_option(self)->help);
}

static PyObject *
gcc_Option_get_is_warning(PyGccOption *self, void *closure)
{
    return PyBool_FromLong(gcc_python_option_to_cl_option(self)->flags & CL_WARNING);
}

static PyObject *
gcc_Option_get_is_optimization(PyGccOption *self, void *closure)
{
    return PyBool_FromLong(gcc_python_option_to_cl_option(self)->flags & CL_OPTIMIZATION);
}

static PyObject *
gcc_Option_get_is_driver(PyGccOption *self, void *closure)
{
    return PyBool_FromLong(gcc_python_option_to_cl_option(self)->flags & CL_DRIVER);
}

static PyObject *
gcc_Option_get_is_target(PyGccOption *self, void *closure)
{
    return PyBool_FromLong(gcc_python_option_to_cl_option(self)->flags & CL_TARGET);
}

static PyGetSetDef gcc_Option_getset_table[] = {
    {"text",
     (getter)gcc_Option_get_text,
     (setter)NULL,
     "(string) The command-line text used to set this option",
     NULL},
    {"help",
     (getter)gcc_Option_get_help,
     (setter)NULL,
     "(string) The help text shown for this option",
     NULL},
    {"is_warning",
     (getter)gcc_Option_get_is_warning,
     (setter)NULL,
     "(bool) Does this option control a warning message?",
     NULL},
    {"is_optimization",
     (getter)gcc_Option_get_is_optimization,
     (setter)NULL,
     "(bool) Does this option control an optimization?",
     NULL},
    {"is_driver",
     (getter)gcc_Option_get_is_driver,
     (setter)NULL,
     "(bool) Is this a driver option?",
     NULL},
    {"is_target",
     (getter)gcc_Option_get_is_target,
     (setter)NULL,
     "(bool) Is this a target-specific option?",
     NULL},
    {"is_enabled",
     (getter)gcc_Option_is_enabled,
     (setter)NULL,
     "True/False for whether or not this option is enabled, raising a NotImplementedError for options for which the plugin cannot tell",
     NULL},
    {NULL}  /* Sentinel */
};

PyTypeObject gcc_OptionType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.Option", /*tp_name*/
    sizeof(struct PyGccOption), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = (reprfunc)gcc_Option_repr,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = gcc_Option_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)gcc_Option_init,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


int autogenerated_option_init_types(void)
{
    if (PyType_Ready(&gcc_OptionType) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_option_add_types(PyObject *m)
{
    Py_INCREF(&gcc_OptionType);
    PyModule_AddObject(m, "Option", (PyObject *)&gcc_OptionType);


}

