/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "params.h"

/**** Prototypes ****/


#define PARAM_INFO(self) (compiler_params[(self)->param_num])

/**** Definitions ****/

static PyObject *
gcc_Parameter_get_option(PyGccParameter *self, void *closure)
{
    return gcc_python_string_or_none(PARAM_INFO(self).option);
}

static PyObject *
gcc_Parameter_get_default_value(PyGccParameter *self, void *closure)
{
    return gcc_python_int_from_long(PARAM_INFO(self).default_value);
}

static PyObject *
gcc_Parameter_get_min_value(PyGccParameter *self, void *closure)
{
    return gcc_python_int_from_long(PARAM_INFO(self).min_value);
}

static PyObject *
gcc_Parameter_get_max_value(PyGccParameter *self, void *closure)
{
    return gcc_python_int_from_long(PARAM_INFO(self).max_value);
}

static PyObject *
gcc_Parameter_get_help(PyGccParameter *self, void *closure)
{
    return gcc_python_string_or_none(PARAM_INFO(self).help);
}

static PyObject *
gcc_Parameter_get_current_value(PyGccParameter *self, void *closure)
{
    return gcc_python_int_from_long(PARAM_VALUE(self->param_num));
}

static int
gcc_Parameter_set_current_value(PyGccParameter *self, PyObject *value, void *closure)
{
    if (! gcc_python_int_check(value)) {
        PyErr_SetString(PyExc_TypeError,
                        "current_value must be an int");
        return -1;
    }
    global_options.x_param_values[self->param_num] = gcc_python_int_as_long(value);
    return 0;
}

static PyGetSetDef gcc_Parameter_getset_table[] = {
    {"option",
     (getter)gcc_Parameter_get_option,
     (setter)NULL,
     "(string) The name used with the `--param <name>=<value>' switch to set this value",
     NULL},
    {"default_value",
     (getter)gcc_Parameter_get_default_value,
     (setter)NULL,
     "(int/long)",
     NULL},
    {"min_value",
     (getter)gcc_Parameter_get_min_value,
     (setter)NULL,
     "(int/long) The minimum acceptable value",
     NULL},
    {"max_value",
     (getter)gcc_Parameter_get_max_value,
     (setter)NULL,
     "(int/long) The maximum acceptable value, if greater than min_value",
     NULL},
    {"help",
     (getter)gcc_Parameter_get_help,
     (setter)NULL,
     "(string) A short description of the option.",
     NULL},
    {"current_value",
     (getter)gcc_Parameter_get_current_value,
     (setter)gcc_Parameter_set_current_value,
     "(int/long)",
     NULL},
    {NULL}  /* Sentinel */
};

PyTypeObject gcc_ParameterType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.Parameter", /*tp_name*/
    sizeof(struct PyGccParameter), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = gcc_Parameter_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)NULL,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


int autogenerated_parameter_init_types(void)
{
    if (PyType_Ready(&gcc_ParameterType) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_parameter_add_types(PyObject *m)
{
    Py_INCREF(&gcc_ParameterType);
    PyModule_AddObject(m, "Parameter", (PyObject *)&gcc_ParameterType);


}

