/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "tree-pass.h"

/**** Prototypes ****/


/**** Definitions ****/

static PyObject *
gcc_Pass_get_name(PyGccPass *self, void *closure)
{
    return gcc_python_string_from_string(self->pass->name);
}

static PyObject *
gcc_Pass_get_next(PyGccPass *self, void *closure)
{
    return gcc_python_make_wrapper_pass(self->pass->next);
}

static PyObject *
gcc_Pass_get_sub(PyGccPass *self, void *closure)
{
    return gcc_python_make_wrapper_pass(self->pass->sub);
}

static PyObject *
gcc_Pass_get_properties_required(PyGccPass *self, void *closure)
{
    return gcc_python_int_from_long(self->pass->properties_required);
}

static PyObject *
gcc_Pass_get_properties_provided(PyGccPass *self, void *closure)
{
    return gcc_python_int_from_long(self->pass->properties_provided);
}

static PyObject *
gcc_Pass_get_properties_destroyed(PyGccPass *self, void *closure)
{
    return gcc_python_int_from_long(self->pass->properties_destroyed);
}

static PyGetSetDef gcc_Pass_getset_table[] = {
    {"name",
     (getter)gcc_Pass_get_name,
     (setter)NULL,
     "Name of the pass",
     NULL},
    {"next",
     (getter)gcc_Pass_get_next,
     (setter)NULL,
     "The next gcc.Pass after this one, or None",
     NULL},
    {"sub",
     (getter)gcc_Pass_get_sub,
     (setter)NULL,
     "The first sub-pass (gated by this pass' predicate, if any)",
     NULL},
    {"properties_required",
     (getter)gcc_Pass_get_properties_required,
     (setter)NULL,
     "NULL",
     NULL},
    {"properties_provided",
     (getter)gcc_Pass_get_properties_provided,
     (setter)NULL,
     "NULL",
     NULL},
    {"properties_destroyed",
     (getter)gcc_Pass_get_properties_destroyed,
     (setter)NULL,
     "NULL",
     NULL},
    {NULL}  /* Sentinel */
};
static PyMethodDef gcc_Pass_methods[] = {
    {"get_roots",  gcc_Pass_get_roots, METH_CLASS | METH_VARARGS,
     "Get a tuple of gcc.Pass instances, the roots of the compilation pass tree"},
    {"get_by_name",  (PyCFunction)gcc_Pass_get_by_name, METH_CLASS | METH_VARARGS | METH_KEYWORDS,
     "Get the gcc.Pass instance for the pass with the given name, raising ValueError if it isn't found"},
    {"register_after",  (PyCFunction)gcc_Pass_register_after, METH_VARARGS | METH_KEYWORDS,
     "Given the name of another pass, register this gcc.Pass to occur immediately after that other pass"},
    {"register_before",  (PyCFunction)gcc_Pass_register_before, METH_VARARGS | METH_KEYWORDS,
     "Given the name of another pass, register this gcc.Pass to occur immediately before that other pass"},
    {"replace",  (PyCFunction)gcc_Pass_replace, METH_VARARGS | METH_KEYWORDS,
     "Given the name of another pass, replace that pass with this gcc.Pass"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};

PyTypeObject gcc_PassType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.Pass", /*tp_name*/
    sizeof(struct PyGccPass), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = (reprfunc)gcc_Pass_repr,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = (reprfunc)gcc_Pass_repr,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = Py_TPFLAGS_DEFAULT,
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = gcc_Pass_methods,
    .tp_members = NULL,
    .tp_getset = gcc_Pass_getset_table,
    .tp_base = NULL,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)NULL,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


PyTypeObject gcc_GimplePassType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.GimplePass", /*tp_name*/
    sizeof(struct PyGccPass), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = NULL,
    .tp_base = &gcc_PassType,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)gcc_GimplePass_init,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


PyTypeObject gcc_RtlPassType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.RtlPass", /*tp_name*/
    sizeof(struct PyGccPass), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = NULL,
    .tp_base = &gcc_PassType,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)gcc_RtlPass_init,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


PyTypeObject gcc_SimpleIpaPassType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.SimpleIpaPass", /*tp_name*/
    sizeof(struct PyGccPass), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = NULL,
    .tp_base = &gcc_PassType,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)gcc_SimpleIpaPass_init,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


PyTypeObject gcc_IpaPassType = {
    PyVarObject_HEAD_INIT(0, 0)
    "gcc.IpaPass", /*tp_name*/
    sizeof(struct PyGccPass), /*tp_basicsize*/
    0, /*tp_itemsize*/
    .tp_dealloc = NULL,
    .tp_print = NULL,
    .tp_getattr = NULL,
    .tp_setattr = NULL,
#if PY_MAJOR_VERSION < 3
    0, /*tp_compare*/
#else
    0, /*reserved*/
#endif
    .tp_repr = NULL,
    .tp_as_number = NULL,
    .tp_as_sequence = NULL,
    .tp_as_mapping = NULL,
    .tp_hash = NULL,
    .tp_call = NULL,
    .tp_str = NULL,
    .tp_getattro = NULL,
    .tp_setattro = NULL,
    .tp_as_buffer = NULL,
    .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
    0, /*tp_doc*/
    .tp_traverse = NULL,
    .tp_clear = NULL,
    .tp_richcompare = NULL,
    0, /* tp_weaklistoffset */
    .tp_iter = NULL,
    .tp_iternext = NULL,
    .tp_methods = NULL,
    .tp_members = NULL,
    .tp_getset = NULL,
    .tp_base = &gcc_PassType,
    .tp_dict = NULL,
    .tp_descr_get = NULL,
    .tp_descr_set = NULL,
    0, /* tp_dictoffset */
    .tp_init = (initproc)gcc_IpaPass_init,
    .tp_alloc = NULL,
    .tp_new = PyType_GenericNew,
    .tp_free = NULL,
    .tp_is_gc = NULL,
    .tp_bases = NULL,
    .tp_mro = NULL,
    .tp_cache = NULL,
    .tp_subclasses = NULL,
    .tp_weaklist = NULL,
    .tp_del = NULL,
#if PY_VERSION_HEX >= 0x02060000
    0, /*tp_version_tag*/
#endif
};


int autogenerated_pass_init_types(void)
{
    if (PyType_Ready(&gcc_PassType) < 0)
        goto error;

    if (PyType_Ready(&gcc_GimplePassType) < 0)
        goto error;

    if (PyType_Ready(&gcc_RtlPassType) < 0)
        goto error;

    if (PyType_Ready(&gcc_SimpleIpaPassType) < 0)
        goto error;

    if (PyType_Ready(&gcc_IpaPassType) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_pass_add_types(PyObject *m)
{
    Py_INCREF(&gcc_PassType);
    PyModule_AddObject(m, "Pass", (PyObject *)&gcc_PassType);

    Py_INCREF(&gcc_GimplePassType);
    PyModule_AddObject(m, "GimplePass", (PyObject *)&gcc_GimplePassType);

    Py_INCREF(&gcc_RtlPassType);
    PyModule_AddObject(m, "RtlPass", (PyObject *)&gcc_RtlPassType);

    Py_INCREF(&gcc_SimpleIpaPassType);
    PyModule_AddObject(m, "SimpleIpaPass", (PyObject *)&gcc_SimpleIpaPassType);

    Py_INCREF(&gcc_IpaPassType);
    PyModule_AddObject(m, "IpaPass", (PyObject *)&gcc_IpaPassType);


}

